var sndname,mdlname:array[0..255] of string[40];

procedure output_block(var b:space; var hdr:header);
var ip:pointer;
    i:longint absolute ip;
    i2:longint;
    j:word;
    c:byte;
    u:char;
    sg:single;
    s:^word;
    st:string;
    vx,vy:shortint;

    const hexdig:array[0..15] of char = ('0','1','2','3','4','5','6','7',
                                         '8','9','A','B','C','D','E','F');

    procedure writesg;
    begin
         str(sg:11:9,st);
         st[0]:=#10;
         if sg<0 then inc(st[0]);
         if abs(sg)<1 then inc(st[0]);
         write(st);
    end;

    procedure writesg2;
    begin
         i2:=0;
         if (sg<>0) and (abs(sg)<1E-4) then begin
            while abs(sg)<1 do begin inc(i2); sg:=sg*10; end;
         end;
         str(sg:15:13,st);
         st[0]:=#10;
         if sg<0 then inc(st[0]);
         if abs(sg)<1 then inc(st[0]);
         j:=byte(st[0]);
         if st[j+1]>='5' then begin
            while st[j]='9' do begin st[j]:='0'; dec(j); end;
            inc(st[j]);
         end;
         if st='-0.00000000' then st:='0.000000000';
         if i2<>0 then st:=st+'e-0'+char(i2+48);
         write(st);
    end;

    procedure coord;
    begin
         sg:=integer(ip^);
         sg:=sg*0.125;
         inc(i,2);
         writesg;
    end;

    procedure cstring;
    begin
         repeat
               c:=byte(ip^);
               inc(i);
               if c=0 then exit;
               if c=ord('"') then write('\"')
               else if c=92 then write('\\')
               else if c>=32 then write(char(c))
               else if c=10 then write('\n')
               else write('\0',(c and 37) shr 3,c and 7);
         until false;
    end;

    procedure angle;
    begin
         sg:=shortint(ip^);
         sg:=sg/256*360;
         inc(i);
         writesg;
    end;

    procedure stringarray(s:string);
    begin
         write(s);
         j:=0; c:=9;
         repeat
               i2:=i;
               while byte(ip^)<>0 do inc(i);
               if i<>i2 then begin
                  move(pointer(i2)^,st[1],i-i2);
                  st[0]:=char(i-i2);
                  inc(j);
                  if s[3]='m' then mdlname[j]:=st else sndname[j]:=st;
                  if c+3+byte(st[0])>=80 then begin
                     writeln(' '); write('  '); c:=2;
                  end;
                  write(' "',st,'"');
                  inc(c,3+byte(st[0]));
               end;
               inc(i);
         until i=i2+1;
         writeln(';');
    end;

    procedure pbyte(s:string);
    begin
         write(s); sg:=shortint(ip^); writesg;
         writeln(';'); inc(i);
    end;

    procedure bitcheck(w:word; bits:longint; count:word);
    var i:word;
    begin
         if bits=0 then exit;
         case w of
           0: write('  weapons');
           1: write('  ammotype');
           2: write('  armortype');
           3: write('  keys');
           4: write('  power_ups');
           5: write('  runes');
           6: write('  weapon');
         end;
         for i:=1 to count do begin
             if (bits and $01)<>0 then write(' ',i);
             bits:=bits shr 1;
         end;
         writeln(';');
    end;

    procedure pmdl;
    begin
         if (byte(ip^)=0) or (mdlname[byte(ip^)][1]='*') then begin
            writeln(';');
         end else begin
            writeln('; // ',mdlname[byte(ip^)]);
         end;
    end;

begin
     ip:=@b;
     writeln('block {');
     write(' camera ');
     sg:=hdr.a1; writesg2; write(' ');
     sg:=hdr.a2; writesg2; write(' ');
     sg:=hdr.a3; writesg2; writeln(';');
     repeat
       case byte(ip^) of
          $00: begin (* bad *)
                     writeln(' bad;');
                     inc(i);
               end;
          $01: begin (* nop *)
                     writeln(' nop;');
                     inc(i);
               end;
          $02: begin (* disconnect *)
                     writeln(' disconnect;');
                     inc(i);
               end;
          $03: begin (* updatestat *)
                     writeln(' updatestat {');
                     inc(i); writeln('  index ',byte(ip^),';');
                     inc(i); writeln('  value ',longint(ip^),';');
                     inc(i,4);
                     writeln(' }');
               end;
          $04: begin (* version *)
                     inc(i);
                     writeln(' version ',longint(ip^),';');
                     inc(i,4);
               end;
          $05: begin (* setview *)
                     inc(i);
                     writeln(' setview ',word(ip^),';');
                     inc(i,2);
               end;
          $06: begin (* sound *)
                     writeln(' sound {');
                     inc(i); j:=byte(ip^);
                     if (j and $1)<>0 then begin
                        inc(i); sg:=byte(ip^)/255;
                        write('  vol '); writesg; writeln(';');
                     end;
                     if (j and $2)<>0 then begin
                        inc(i); sg:=byte(ip^)/64;
                        write('  attenuation '); writesg; writeln(';');
                     end;
                     inc(i);
                     writeln('  channel ',word(ip^) and $7,';');
                     writeln('  entity ',word(ip^) shr 3,';');
                     inc(i,2);
                     writeln('  soundnum ',byte(ip^),'; // ',sndname[byte(ip^)]);
                     inc(i); write('  origin ');
                     coord; write(' '); coord; write(' '); coord; writeln(';');
                     writeln(' }');
               end;
          $07: begin (* time *)
                     inc(i); write(' time ');
                     sg:=single(ip^);
                     j:=trunc(sg/3600);
                     sg:=sg-j*3600;
                     i2:=trunc(sg/60);
                     sg:=sg-i2*60;
                     u:='s';
                     if i2<>0 then u:='m';
                     if j<>0 then u:='h';
                     if j<>0 then write(j,':');
                     if i2<>0 then begin
                        if (j<>0) and (i2<10) then write('0');
                        write(i2,':');
                     end;
                     str((int(sg*1E8)+int(frac(sg*1E8)*2))/1E8:10:8,st);
                     j:=pos('.',st)+8;
                     st[0]:=char(j);
                     writeln(st,u,';');
                     inc(i,4);
               end;
          $08: begin (* print *)
                     inc(i);
                     write(' print "');
                     cstring;
                     writeln('";');
               end;
          $09: begin (* stufftext *)
                     inc(i);
                     write(' stufftext "');
                     cstring;
                     writeln('";');
               end;
          $0a: begin (* setangle *)
                     write(' setangle ');
                     inc(i);
                     angle; write(' ');
                     angle; write(' ');
                     angle; writeln(';');
               end;
          $0b: begin (* serverinfo *)
                     writeln(' serverinfo {');
                     inc(i); writeln('  serverversion ',longint(ip^),';');
                     inc(i,4); writeln('  maxclients ',byte(ip^),';');
                     inc(i); writeln('  multi ',byte(ip^),';');
                     inc(i); write('  mapname "'); cstring; writeln('";');
                     stringarray('  models');
                     stringarray('  sounds');
                     writeln(' }');
               end;
          $0c: begin (* lightstyle *)
                     writeln(' lightstyle {');
                     inc(i); writeln('  style ',byte(ip^),';');
                     inc(i); write('  string "'); cstring; writeln('";');
                     writeln(' }');
               end;
          $0d: begin (* updatename *)
                     writeln(' updatename {');
                     inc(i); writeln('  player ',byte(ip^),';');
                     inc(i); write('  netname "'); cstring; writeln('";');
                     writeln(' }');
               end;
          $0e: begin (* updatefrags *)
                     writeln(' updatefrags {');
                     inc(i); writeln('  player ',byte(ip^),';');
                     inc(i); writeln('  frags ',integer(ip^),';');
                     inc(i,2); writeln(' }');
               end;
          $0f: begin (* clientdata *)
                     writeln(' clientdata {');
                     inc(i); s:=ip; inc(i,2);
                     if (s^ and $01)<>0 then pbyte('  view_ofs_z ');
                     if (s^ and $02)<>0 then pbyte('  punchangle_x ');
                     if (s^ and $04)<>0 then pbyte('  angles_1 ');
                     if (s^ and $20)<>0 then begin vx:=shortint(ip^); inc(i); end;
                     if (s^ and $08)<>0 then pbyte('  angles_2 ');
                     if (s^ and $40)<>0 then begin vy:=shortint(ip^); inc(i); end;
                     if (s^ and $10)<>0 then pbyte('  angles_3 ');
                     if (s^ and $20)<>0 then begin
                        write('  vel_x '); sg:=vx; writesg; writeln(';');
                     end;
                     if (s^ and $40)<>0 then begin
                        write('  vel_y '); sg:=vy; writesg; writeln(';');
                     end;
                     if (s^ and $80)<>0 then pbyte('  vel_z ');
                     i2:=longint(ip^); inc(i,4);
                     bitcheck(0,((i2 shl  1) and $01fe) or
                                          ((i2 shr 12) and $0001),9);
                     bitcheck(1,(i2 shr 8) and $0f,4);
                     bitcheck(2,(i2 shr 13) and $07,3);
                     if (i2 and $00010000)<>0 then writeln('  megahealth;');
                     bitcheck(3,(i2 shr 17) and $03,2);
                     bitcheck(4,(i2 shr 19) and $0f,4);
                     if (i2 and $00800000)<>0 then writeln('  uk_items_b23;');
                     if (i2 and $01000000)<>0 then writeln('  uk_items_b24;');
                     if (i2 and $02000000)<>0 then writeln('  uk_items_b25;');
                     if (i2 and $04000000)<>0 then writeln('  uk_items_b26;');
                     if (i2 and $08000000)<>0 then writeln('  uk_items_b27;');
                     bitcheck(5,(i2 shr 28) and $0f,4);
                     if (s^ and $0400)<>0 then writeln('  uk_bit_b10;');
                     if (s^ and $0800)<>0 then writeln('  uk_bit_b11;');
                     if (s^ and $1000)<>0 then begin
                        writeln('  weaponframe ',byte(ip^),';'); inc(i);
                     end;
                     if (s^ and $2000)<>0 then begin
                        writeln('  armorvalue ',byte(ip^),';'); inc(i);
                     end;
                     if (s^ and $4000)<>0 then begin
                        write('  weaponmodel ',byte(ip^)); pmdl; inc(i);
                     end;
                     writeln('  health ',integer(ip^),';'); inc(i,2);
                     writeln('  currentammo ',byte(ip^),';'); inc(i);
                     writeln('  ammo_shells ',byte(ip^),';'); inc(i);
                     writeln('  ammo_nails ',byte(ip^),';'); inc(i);
                     writeln('  ammo_rockets ',byte(ip^),';'); inc(i);
                     writeln('  ammo_cells ',byte(ip^),';'); inc(i);
                     i2:=byte(ip^) shl 1;
                     if i2=0 then i2:=1;
                     bitcheck(6,i2,9);
                     inc(i);
                     writeln(' }');
               end;
          $10: begin (* stopsound *)
                     inc(i); writeln(' stopsound ',word(ip^),';');
                     inc(i,2);
               end;
          $11: begin (* updatecolors *)
                     writeln(' updatecolors {');
                     inc(i); writeln('  player ',byte(ip^),';');
                     inc(i); writeln('  colors ',byte(ip^) shr 4,' ',
                                                 byte(ip^) and $f,';');
                     inc(i);
                     writeln(' }');
               end;
          $12: begin (* particle *)
                     writeln(' particle {');
                     inc(i); write('  origin ');
                     coord; write(' '); coord; write(' '); coord; writeln(';');
                     write('  vel '); sg:=shortint(ip^)*0.0625; writesg; write(' ');
                     inc(i); sg:=shortint(ip^)*0.0625; writesg; write(' ');
                     inc(i); sg:=shortint(ip^)*0.0625; writesg; writeln(';');
                     inc(i); writeln('  color ',byte(ip^),';');
                     inc(i); writeln('  count ',byte(ip^),';');
                     inc(i); writeln(' }');
               end;
          $13: begin (* damage *)
                     writeln(' damage {');
                     inc(i); writeln('  save ',byte(ip^),';');
                     inc(i); writeln('  take ',byte(ip^),';');
                     inc(i); write('  origin ');
                     coord; write(' '); coord; write(' '); coord; writeln(';');
                     writeln(' }');
               end;
          $14: begin (* spawnstatic *)
                     writeln(' spawnstatic {');
                     inc(i); write('  default_modelindex ',byte(ip^)); pmdl;
                     inc(i); writeln('  default_frame ',byte(ip^),';');
                     inc(i); writeln('  default_colormap ',byte(ip^),';');
                     inc(i); writeln('  default_skin ',byte(ip^),';');
                     inc(i); write('  default_origin '); coord;
                     inc(i); write(' '); coord;
                     inc(i); write(' '); coord; writeln(';');
                     dec(i,6); write('  default_angles '); angle;
                     inc(i,2); write(' '); angle;
                     inc(i,2); write(' '); angle; writeln(';');
                     writeln(' }');
               end;
          $15: begin (* spawnbinary *)
                     writeln(' spawnbinary;');
                     inc(i);
               end;
          $16: begin (* spawnbaseline *)
                     writeln(' spawnbaseline {');
                     inc(i); writeln('  entity ',word(ip^),';');
                     inc(i,2); write('  default_modelindex ',byte(ip^)); pmdl;
                     inc(i); writeln('  default_frame ',byte(ip^),';');
                     inc(i); writeln('  default_colormap ',byte(ip^),';');
                     inc(i); writeln('  default_skin ',byte(ip^),';');
                     inc(i); write('  default_origin '); coord;
                     inc(i); write(' '); coord;
                     inc(i); write(' '); coord; writeln(';');
                     dec(i,6); write('  default_angles '); angle;
                     inc(i,2); write(' '); angle;
                     inc(i,2); write(' '); angle; writeln(';');
                     writeln(' }');
               end;
          $17: begin (* temp_entity *)
                     writeln(' temp_entity {');
                     inc(i); writeln('  entitytype ',byte(ip^),';');
                     j:=byte(ip^); inc(i);
                     if (j=12) or (j=13) then begin
                        writeln(' }');
                        writeln(' unknown {');
                        write('  id 0x');
                        write(hexdig[(byte(ip^) and $f0) shr 4]);
                        write(hexdig[byte(ip^) and $0f]);
                        writeln(';');
                        inc(i);
                        write('  data');
                        if j=12 then j:=7 else j:=13;
                        for c:=1 to j do begin
                            write(' 0x');
                            write(hexdig[(byte(ip^) and $f0) shr 4]);
                            write(hexdig[byte(ip^) and $0f]);
                            inc(i);
                        end;
                        writeln(';');
                     end else begin
                        if (j=5) or (j=6) or (j=9) then begin
                           writeln('  entity ',word(ip^),';');
                           inc(i,2);
                        end;
                        write('  origin '); coord; write(' ');
                        coord; write(' '); coord; writeln(';');
                        if (j=5) or (j=6) or (j=9) then begin
                           write('  trace_endpos '); coord; write(' ');
                           coord; write(' '); coord; writeln(';');
                        end;
                     end;
                     writeln(' }');
               end;
          $18: begin (* setpause *)
                     inc(i); writeln(' setpause ',byte(ip^),';');
                     inc(i);
               end;
          $19: begin (* signon *)
                     inc(i); writeln(' signonnum ',byte(ip^),';');
                     inc(i);
               end;
          $1a: begin (* centerprint *)
                     inc(i);
                     write(' centerprint "');
                     cstring;
                     writeln('";');
               end;
          $1b: begin (* killedmonster *)
                     writeln(' killedmonster;'); inc(i);
               end;
          $1c: begin (* foundsecret *)
                     writeln(' foundsecret;'); inc(i);
               end;
          $1d: begin (* spawnstaticsound *)
                     inc(i); writeln(' spawnstaticsound {');
                     write('  origin '); coord; write(' ');
                     coord; write(' '); coord; writeln(';');
                     writeln('  soundnum ',byte(ip^),'; // ',sndname[byte(ip^)]);
                     inc(i); sg:=byte(ip^)/255;
                     write('  vol '); writesg; writeln(';');
                     inc(i); sg:=byte(ip^)/64;
                     write('  attenuation '); writesg; writeln(';');
                     inc(i);
                     writeln(' }');
               end;
          $1e: begin (* intermission *)
                     writeln(' intermission;');
                     inc(i);
               end;
          $1f: begin (* finale *)
                     inc(i);
                     write(' finale "');
                     cstring;
                     writeln('";');
               end;
          $20: begin (* cdtrack *)
                     writeln(' cdtrack {'); inc(i);
                     writeln('  fromtrack ',byte(ip^),';'); inc(i);
                     writeln('  totrack ',byte(ip^),';'); inc(i);
                     writeln(' }');
               end;
          $21: begin (* sellscreen *)
                     writeln(' sellscreen;');
                     inc(i);
               end;
          $22: begin (* cutscene *)
                     writeln(' unknown {');
                     writeln('  id 0x22;');
                     write('  data');
                     repeat
                           inc(i);
                           write(' 0x');
                           write(hexdig[(byte(ip^) and $f0) shr 4]);
                           write(hexdig[byte(ip^) and $0f]);
                     until byte(ip^)=0;
                     writeln(';');
                     writeln(' }');
                     inc(i);
               end;
          $23..$7f: ewriteln('ERROR');
          $80..$ff:
               begin (* updateentity *)
                     writeln(' updateentity {');
                     j:=byte(ip^) and $7f;
                     if (j and $01)<>0 then begin
                        inc(i); j:=j or (byte(ip^) shl 8);
                     end;
                     inc(i);
                     if (j and $4000)<>0 then begin
                        writeln('  entity ',word(ip^),';'); inc(i,2);
                     end else begin
                        writeln('  entity ',byte(ip^),';'); inc(i);
                     end;
                     if (j and $0400)<>0 then begin
                        write('  modelindex ',byte(ip^)); pmdl; inc(i);
                     end;
                     if (j and $0040)<>0 then begin
                        writeln('  frame ',byte(ip^),';'); inc(i);
                     end;
                     if (j and $0800)<>0 then begin
                        writeln('  colormap ',byte(ip^),';'); inc(i);
                     end;
                     if (j and $1000)<>0 then begin
                        writeln('  skin ',byte(ip^),';'); inc(i);
                     end;
                     if (j and $2000)<>0 then begin
                        writeln('  effects ',byte(ip^),';'); inc(i);
                     end;
                     if (j and $0002)<>0 then begin
                        write('  origin_x '); coord; writeln(';');
                     end;
                     if (j and $0100)<>0 then begin vx:=byte(ip^); inc(i); end;
                     if (j and $0004)<>0 then begin
                        write('  origin_y '); coord; writeln(';');
                     end;
                     if (j and $0010)<>0 then begin vy:=byte(ip^); inc(i); end;
                     if (j and $0008)<>0 then begin
                        write('  origin_z '); coord; writeln(';');
                     end;
                     if (j and $0100)<>0 then begin
                        write('  angles_1 ');
                        sg:=vx/256*360; writesg;
                        writeln(';');
                     end;
                     if (j and $0010)<>0 then begin
                        write('  angles_2 ');
                        sg:=vy/256*360; writesg;
                        writeln(';');
                     end;
                     if (j and $0200)<>0 then begin
                        write('  angles_3 '); angle; writeln(';');
                     end;
                     if (j and $0020)<>0 then writeln('  new;');
                     writeln(' }');
               end;
       end;
    until i>=longint(@b[hdr.len]);
    writeln('}');
end;